	.386p
	jumps

code32  segment para public use32
	assume cs:code32, ds:code32

include ..\pmode.inc
include ..\xmode\xmode.inc

public  _main

;
; DATA
;

include          sincos.inc

POSTXADD         equ 160
POSTYADD         equ 100

Z_SHIFT          equ 3                   ; Depth fade strength (3 or 4 looks best)
COR_MUL          equ 7                   ; Coordinate multiply (SHL!) for box   (normally 7)
COR_MUL_NR       equ 1 SHL COR_MUL       ; 'Real' multiplier for cor_mul

chek_bounds      =   1                   ; 1 = chek offscreen points / 0 = don't
do_depth_fade    =   1                   ; 1 = points grow darker as they are further from viewer / 0 = njet
chek_before_scr  =   1                   ; 1 = check wether or not points that are behind the viewer should be drawn (CLC / STC sytem)

sq_wid           equ 10                  ; These MUST be even numbers!!
sq_dep           equ 10                  ; (or else)
sqrs             equ 20

		 ; This is a formula that'll calculate the number of points
		 ; in the 3D box... not!
nr_cap           equ sq_wid*sq_dep
nr_frame         equ sq_wid*2 + (sq_dep)*2

nrpnts           equ nr_cap*2 + nr_frame*(sqrs) + 100


align 4
magikbox         dw  nrpnts*3 dup (?)  ; X, Y, Z in words ..
		 dw  01234h              ;.. and a terminator

clrbuf_ptr1      dd  ?                   ; Screen Clear Buffer Pointer (whaa) page 1
clrbuf_ptr2      dd  ?                   ; page 2
clrbuf_ctr       dd  ?

align 4
xangle           dw  0                   ; The Angles.
align 4              
yangle           dw  0
align 4
zangle           dw  0,0                 ; This is a fixed murmel...
		     
align 4
transformroutine dd  offset _ret         ; Nothin' yet.
ZADD             dd  -3000

; Speedup at start
murmel           dw  200                 ; wait 200 frames before rotating x & y
spd              dd  10h


; Transformation variables
zmulfix          dd  20000h              ; 1.0: Normal display...
speed            dd  800h                ; This means: strechting out by 'speed' units / animframe
stugheid         dd  -200h               ; Don't have an English translation handy: de stugheid van de veer / groter = stugger

rotated_Z        dd  ?                   ; Rotated Z coordinate of last
					 ; point that went through do_3d. Can be      
					 ; used for colors fading away in depth...

; GBU box variables
twist            dd 0h                   ; Twister... 16.16 fixed point  0->nothing

palette          LABEL BYTE              ; Grayvalued palette...
		 i=0
		 REPT 256
			DB      i SHR 2, i SHR 2, i SHR 2
			i=i+1
		 ENDM

;
; CODE
;


_main:
	sti

	call make_box         ; Make that awesome murmelding!
	
	pushw 0
	call set_modex

if do_depth_fade eq 1
	; Set a new palette...
	push  o palette
	pushw 0
	pushw 255
	pushw 1
	call  load_dac_registers
endif

       ;mov transformroutine, offset xform_dots         ; Bounce and stuff
	mov transformroutine, offset xform_boxrotate    ; gbu boxje.. hoei!!

	call init_csb           ; Init clear screen buffer (points
				;   must be inited!)


	call initpages


mainlp:
	call flippages

	call delete_object      ; Yess.. faster than clear_vga_screen

	mov  esi, o magikbox
	call display_object
COMMENT $
	ror d zangle, 16

	cmp murmel, 0
	jne doz
	add xangle, 1
	and xangle, 0ffh

	add yangle, 1
	and yangle, 0ffh
	jmp dontdec
doz:
	dec murmel
	add spd, 400h
dontdec:
;        add zangle, 1
;        and zangle, 0ffh
	mov  eax, spd
	add d zangle, eax
	and d zangle, 0FFFFFFh

	ror d zangle, 16
$


; complete rotation..
;comment ^
	add  xangle, 1
	and  xangle, 0ffh
	add  yangle, 1
	and  yangle, 0ffh
	add  zangle, 1
	and  zangle, 0ffh
	;^

; Uncomment this and the figure will morph all over the place
COMMENT $
;---- Update zmulfix
	mov  eax, speed
	add  zmulfix, eax               ; This is the 'stretch value' 16.16
	mov  eax, stugheid
	add  speed, eax
	cmp  zmulfix, 10000h
	jg   neg_stug
;pos_stug:
	or   eax, eax
	jns  rdy
	neg  stugheid
	jmp  rdy
neg_stug:
	or   eax, eax
	js  rdy
	neg  stugheid
rdy:
$

	; mureling??.. 
	mov  eax, speed
	add  twist, eax
	mov  eax, stugheid
	add  speed, eax
	cmp  twist, 10000h
	jg   neg_stug
;pos_stug:
	or   eax, eax
	jns  rdy
	neg  stugheid
	jmp  rdy
neg_stug:
	or   eax, eax
	js  rdy
	neg  stugheid
rdy:

	in al, 60h
	cmp al,1
	jne mainlp


getout:
	mov ax,3
	int 10h

	jmp _exit       ; Get outta here


;


;
; init_csb
;  initialize the clear screen buffer (a buffer which holds the video offsets
;  for the points)
;
init_csb:
	; Chek how many 3D points there are...
	mov  esi, o magikbox
	clr  eax 

cnt_loop:
	inc  eax
	add  esi, 3*2
	cmp  w [esi], 01234h
	jne  cnt_loop

	; eax -> nr pnts.
	inc  eax
	shl  eax, 2             ; * 4 -> mem size

	add  eax, 100

	;mov  eax, nrpnts*4+40

	push eax 
	call _getlomem          ; Get zome memory... p1
	mov  clrbuf_ptr1, eax
	mov  d [eax], 12345678h
	pop  eax

	call _getlomem          ; Get zome memory... p2
	mov  clrbuf_ptr2, eax
	mov  d [eax], 12345678h

	ret

;
; make_box
;  makes a 3d box.. (haha).. according to sq_wid, sq_dep and sqrs
;
make_box:
	mov  esi, o magikbox
	mov  ax,  0-(sqrs/2)    ; Z of cap...
	call make_cap

	inc  ax

zloop:
	call make_fr            ; Make a frame of dots...
	inc  ax
	cmp  ax,  sqrs/2-1
	jne  zloop

	call make_cap           ; Make the last little cap...


	mov  w [esi], 01234h

	; Resize dis thing...
	mov  esi, o magikbox
zoomloop:
	cmp  w [esi], 01234h
	je   _ret
	shl  w [esi], COR_MUL   ; sar can also do.. (same opcode dude!)
	add  esi, 2
	jmp  zoomloop


; Makes an filled rectangle...
; Z in AX
make_cap:
	mov  bx, 0-(sq_wid/2)
ylp:
	mov  cx, 0-(sq_dep/2)
xlp:
	; Make a point (haha)
	mov  [esi], bx  ; X
	add  esi, 2
	mov  [esi], cx  ; Y
	add  esi, 2
	mov  [esi], ax  ; Z
	add  esi, 2

	mov  edx, esi
	

	inc  cx
	cmp  cx,sq_dep/2
	jne  xlp

	inc  bx
	cmp  bx,sq_wid/2
	jne  ylp

	ret

; Makes a non-filled rectangle
; Z in AX
make_fr:

; Horizontal lines...
	mov  bx, 0-(sq_wid/2)
mf_xlp:
; Top
	mov  [esi], bx
	add  esi, 2
	mov  w [esi], 0-(sq_dep/2)
	add  esi, 2
	mov  [esi], ax
	add  esi, 2
; Bottom
	mov  [esi], bx
	add  esi, 2
	mov  w [esi], sq_dep/2-1
	add  esi, 2
	mov  [esi], ax
	add  esi, 2

	inc  bx
	cmp  bx, sq_wid/2
	jne  mf_xlp

; Vertical lines...
	mov  bx, 0-(sq_dep/2)+1
mf_ylp:
; Top
	mov  w [esi], 0-(sq_wid/2)
	add  esi, 2
	mov  [esi], bx
	add  esi, 2
	mov  [esi], ax
	add  esi, 2
; Bottom
	mov  w [esi], sq_wid/2 -1
	add  esi, 2
	mov  [esi], bx
	add  esi, 2
	mov  [esi], ax
	add  esi, 2

	inc  bx
	cmp  bx, sq_dep/2-1
	jne  mf_ylp

	ret

;
; xform_dots     -- Multiplies Z with fixed pnt 'zmulfix'
; auto-call routine
; In ax: x
;    bx: y
;    cx: z
; Out: idem, but xformed
;
xform_dots:
	push  ax       ; Not used, we're interested in Z!
	movzx ecx,cx
	mov   eax, zmulfix
	imul  ecx
	sar   eax, 16
	mov   cx, ax
	pop   ax
	ret

;
; xform_boxrotate       -- does a GBU rotation on the object, looks best with 
; auto-call routine          a box made with 'make_box'
; In ax: x
;    bx: y
;    cx: z
; Out: idem, but xformed
;
xform_boxrotate:
	;rotate ax, bx
	push  cx                        ; Saze V.. uhh Save Z

	movsx ecx, cx
	add   ecx, sqrs*COR_MUL_NR/2     ; 0 +
	sar   ecx, COR_MUL
	push  eax
	mov   eax, ecx
	imul  twist
	sar   eax, 16
	mov   ecx, eax
	pop   eax
	and   ecx, 0ffh                 ; 256 Degree wraparound
	mov   angle, ecx
	call  do_2d                     ; output: rotated ax,bx

	pop   cx
	ret

;
; display_object
; displays an object...
; In:  esi -> object structure   looks like this ->
;
;      obj    dw x1, y1, z1
;             dw x2, y2, z2
;               .... (etc)
;             dw 01234h ;<- terminator
;
;
display_object:
	; Get act. page...!
	call  get_active_page
	cmp   ax, 0
	jne   gdp1
	mov   eax, clrbuf_ptr1
	jmp   gdp2
gdp1:
	mov   eax, clrbuf_ptr2
gdp2:
	mov   clrbuf_ctr, eax

do_loop:
	; Get coords.
	mov   ax, [esi]
	mov   bx, [esi+2]
	mov   cx, [esi+4]
	push  esi

	call  [transformroutine]
	call  do_3d

if chek_bounds eq 1
	jc    dont_stpnt         ; Jump over if outside screen
endif

if do_depth_fade eq 1
	mov   edx, ZADD
	sar   edx, 1
	add   edx, ZADD
	sub   ecx, edx           ; Reverese ZADD.. -- = +
	shr   ecx, Z_SHIFT

	cmp   cx, 255
	jng   no_up
	mov   cx, 255           ; Max value = 255
no_up:

	cmp   cx, 1
	jnl   no_dwn
	mov   cx, 1             ; Minimun value = 1 (0 for bg)
no_dwn:

else
	mov   cx, 15            ; Normal drawing color.. change dis if you like
endif

	push    cx                        ; COLOR

	push    ax                        ; X

	mov     edi, current_page

	movzx   eax, bx
	shl     eax, 1
	movzx   eax, [screentable+eax]    ; AX = AX*80
	add     edi, eax                  ; Add row

	pop     bx                        ; X

	movzx   ebx, bx
	mov     cx, bx
	shr     ebx, 2                    ; /4
	add     edi, ebx

	mov     ax, map_mask_plane1
	and     cl, plane_bits
	shl     ah, cl
	out_16  sc_index, ax

	pop     ax                        ; COLOR
	mov     [edi], al                 ; draw pixel
	mov     ebx, clrbuf_ctr
	mov     [ebx], edi                ; Store offset (all planes enabled when deleting)
	add     clrbuf_ctr, 4

if chek_bounds eq 1
dont_stpnt:
endif

	pop  esi
	add  esi, 3*2
	cmp  w [esi], 01234h
	jne  do_loop

       ; mov  eax, current_page
	mov  ebx, clrbuf_ctr
	;mov  d [ebx], eax
	mov  d [ebx+4], 12345678h         ; terminate..

	ret

;
; delete_object
;   deletes an object displayed with display_object (faster then clearvgascr)
; In: nothing
; Out: ditto
;
delete_object:
	out_16  sc_index, all_planes_on

	call  get_active_page
	cmp   ax, 0
	jne   gdp3
	mov   esi, clrbuf_ptr1
	jmp   gdp4
gdp3:
	mov   esi, clrbuf_ptr2
gdp4:
	
clrlp:
	cmp  d [esi], 12345678h
	je   _ret
	mov  edi, [esi]
	mov  b [edi], 0                   ; Clear all 4 pixels
	add  esi, 4
	jmp  clrlp

;
; do_3d
; In:  ax,bx,cx - coordinates. xangle, yangle, zangle - angles.
; Out:  sx, sy- screen coordinates.
;      [if chek_bounds eq 1]
;      STC:
;       the coordinates are offscreen
;      CLC:
;       they're on the screen (320x200 duh?)
;

align 4
xt      dw ?
yt      dw ?
zt      dw ?
align 4
X       dd 0
Y       dd 0
Z       dd 0

do_3d:
	push ebp
	movsx eax, ax
	mov X, eax
	movsx eax, bx
	mov Y, eax
	movsx ecx, cx
	mov Z, ecx
;                        /* rotate on x-axis */
;                        Yt=(Y*a_cos(X_angle)-Z*a_sin(X_angle)) >> NUMB;
	movsx ebx, xangle
	shl ebx, 2               ; DWord align (*4)
	imul d [ebx+costable]    ; Multiply Y with cosine(xangle)  --> EDX:EAX

	mov ebp, eax               ; Store BP

	mov eax, Z
	imul d [ebx+sintable]      ; Multiply Z with sine(xangle)  --> DX:AX
	sub ebp, eax

	shr ebp, 16             ; Round it up.
	movsx ebp, bp

	mov yt, bp


;                        Zt=(Y*a_sin(X_angle)+Z*a_cos(X_angle)) >> NUMB;
	mov eax, Y
	imul d [ebx+sintable]    ; Multiply Y with cosine(xangle)  --> EDX:EAX

	mov ebp, eax               ; Store BP

	mov eax, Z
	imul d [ebx+costable]      ; Multiply Z with sine(xangle)  --> DX:AX
	add ebp, eax

	shr ebp, 16             ; Round it up.
	movsx ebp, bp

	mov zt, bp

;                        Z=Zt;
	mov Z, ebp

;                        Y=Yt;
	mov ax, yt
	movsx eax, ax
	mov Y, eax

;                        /* rotate on y-axis */
;                        Xt=(X*a_cos(Y_angle)-Z*a_sin(Y_angle)) >> NUMB;
	mov eax, X
	movsx ebx, yangle
	shl ebx, 2               ; DWord align (*4)
	imul d [ebx+costable]    ; Multiply Y with cosine(xangle)  --> EDX:EAX

	mov ebp, eax               ; Store BP

	mov eax, Z
	imul d [ebx+sintable]      ; Multiply Z with sine(xangle)  --> DX:AX
	sub ebp, eax

	shr ebp, 16             ; Round it up.
	movsx ebp, bp

	mov xt, bp

;                        Zt=(X*a_sin(Y_angle)+Z*a_cos(Y_angle)) >> NUMB;
	mov eax, X
	imul d [ebx+sintable]    ; Multiply Y with cosine(xangle)  --> EDX:EAX

	mov ebp, eax               ; Store BP

	mov eax, Z
	imul d [ebx+costable]      ; Multiply Z with sine(xangle)  --> DX:AX
	add ebp, eax

	shr ebp, 16                ; Round it up.
	movsx ebp, bp

	mov zt, bp

;                        Z=Zt;
	mov Z, ebp
;                        X=Xt;
	mov ax, xt
	movsx eax, ax
	mov X, eax

;
;                        /* rotate on z-axis */
;                        Xt=(X*a_cos(Z_angle)-Y*a_sin(Z_angle)) >> NUMB;
;
	mov eax, X
	movsx ebx, zangle
	shl ebx, 2               ; DWord align (*4)
	imul d [ebx+costable]    ; Multiply Y with cosine(xangle)  --> EDX:EAX

	mov ebp, eax               ; Store BP

	mov eax, Y
	imul d [ebx+sintable]      ; Multiply Z with sine(xangle)  --> DX:AX
	sub ebp, eax

	shr ebp, 16             ; Round it up.
	movsx ebp, bp

	mov xt, bp

;                        Yt=(X*a_sin(Z_angle)+Y*a_cos(Z_angle)) >> NUMB;
	mov eax, X
	imul d [ebx+sintable]    ; Multiply Y with cosine(xangle)  --> EDX:EAX

	mov ebp, eax               ; Store BP

	mov eax, Y
	imul d [ebx+costable]      ; Multiply Z with sine(xangle)  --> DX:AX
	add ebp, eax

	shr ebp, 16             ; Round it up.
	movsx ebp, bp

	mov yt, bp

;                        Y=Yt;
	mov Y, ebp
;                        X=Xt;
	mov ax, xt
	movsx eax, ax
	mov X, eax

;                        X=X+Xtv;               [global placement in picture in 3d]
;                        Y=Y+Ytv;
;                        Z=Z+Ztv;


;plan d'action: 
; [x]-thee maken
; [x]-params in de vorm van regs doorgeven
; [x]-X,Y,Z  DWORDs maken
; [x]-overzetting aan begin sub
; [-]-Geen shr ebp, 16 meer!!, of eindresultaten storen en hieronder gebruiken
; [-]-Stukje hieronder aanpassen, komt erop neer dat X,Y,Z niet meer (onnodig) AFGEROND moeten worden
; [x]-ebx meer hardwiren... (geen 2x zangle berekenen voor 1 axis
; [ ]-ebx nog meer hardwiren eerst ebx*2 +sintable [use], dan add ebx, <verschil cos/sintable>, use    [[ denk aan sin/cos en cos/sin (wisselen soms om)  ]]
; [x]-params terug in de vorm van registers?
; [ ]-ipv ebp  edi gebr (push en pop kunnen dan achterwege blijven = tijd!)
; [ ]-betere commentaartjes


;                        ScreenY=((Y+PreYadd)<<8)/(Z+PreZadd)+PostYadd;
	mov     eax,Y                    ; AX = X
	shl     eax,8                    ; AX = (X)<<8
	mov     ecx,Z                    ; BX = Z (hardwired)
	add     ecx,ZADD                 ; BX = Z + PreZadd
	mov     rotated_Z, ecx
if chek_before_scr eq 1
	cmp     ecx, 100
	jng     s no_bscr
	
	pop     ebp                      ; Restore stack
	jmp     s nope_dude
no_bscr:
endif

	cdq                              ; Convert Word To Double... (sign shit)
	idiv    ecx                      ; Divide EDX:EAX with ECX
	add     eax, POSTYADD
	mov     bx, ax                   ; Store result in BX

;                        ScreenX=((X+PreXadd (=0))<<8)/(Z+PreZadd)+PostXadd;
	mov     eax,X                    ; EAX = X
	shl     eax,8                    ; EAX = (X)<<16
	;mov     ecx,rotated_Z           ; (still remains from last)
	cdq                              ; Convert Double To Quad (sign shit) EAX -> EDX:EAX (64 bit QuadWord!!)
	idiv    ecx                      ; Divide EDX:EAX with ECX
	add     eax, POSTXADD
	
	pop     ebp                      ; Restore used base ptr...
	; AX = X, BX = Y
if chek_bounds eq 1
	cmp     ax, 319                  ; Coordinate chek
	ja      nope_dude
	cmp     bx, 199
	ja      nope_dude
	cmp     ax, 0
	jl      nope_dude
	cmp     bx, 0
	jl      nope_dude
	clc
endif
	ret

if chek_bounds eq 1
nope_dude:
	stc     ; Coordinates offscreen exit code
	ret
endif

;--- Used by xform_boxrotate ---

;
; do_2d
;  rotates a point in 2d space (relative to 0,0 origin!)
; In:  ax - X
;      bx - Y
;      angle - angle ranging from 0 to 255
; Out: ax - RotX
;      bx - RotY
; (uses 4 imuls)
;
align 4

;X,Y: C above..
angle   dd 0
do_2d:
;Rotation: new_x = old_x * COS(angle) - old_y * SIN(angle)
;          new_y = old_x * SIN(angle) + old_y * COS(angle)
	movsx eax, ax
	mov   X, eax
	movsx ebx, bx
	mov   Y, ebx

	mov   ebx, angle
	shl   ebx, 2            ; DWORD align
	mov   ecx, [costable+ebx] ; COS(angle)
	imul  ecx               ; X (norm) * cos(angle) 16.16 = 16.16
	push  eax

	mov   ecx, [sintable+ebx] ; SIN(angle)
	mov   eax, Y
	imul  ecx               ; EAX = SIN(angle) * Y = 16.16

	pop   ebx

	sub   ebx, eax          ; x*cos(a)-y*sin(a)

	sar   ebx, 16

	push  bx

	mov   eax, X
	mov   ebx, angle
	shl   ebx, 2             ; DWORD align
	mov   ecx, [sintable+ebx] ; SIN(angle)
	imul  ecx               ; X (norm) * sin(angle) 16.16 = 16.16
	push  eax

	mov   ecx, [costable+ebx] ; COS(angle)
	mov   eax, Y
	imul  ecx               ; EAX = COS(angle) * Y = 16.16

	pop   ebx

	add   ebx, eax          ; x*cos(a)+y*sin(a)

	sar   ebx, 16

	pop   ax                ; AX -> X   /   BX -> Y

	ret


code32  ends
	end
