; 
;  SLIDER.ASM                                           
; Ĳ
;  Smooth 'sliding' movement. For demos.                
;  (PMODE VERSION)                                      
; Ĳ
;  Made by Daan Nusman, ULTRUM SOFT '94                 
; 

        .386p
        jumps

code32  segment para public use32
        assume cs:code32, ds:code32

include ..\pmode.inc

; 
;  PUBS                                                 
; 

PUBLIC init_slider
PUBLIC slider_update

PUBLIC SlideX
PUBLIC SlideY
PUBLIC DestX
PUBLIC DestY

; 
;  DATA                                                 
; 

SlideX  dw ?
SlideY  dw ?
DestX   dw ?
DestY   dw ?

; The Slide Structure needs  some explenation: it's  just 
; xx bytes, wich contain data for slide_update. The first
; two WORDS are the X and Y coordinates, in SINGED words.
; They can be inited in INIT_SLIDER

; WORD X            ; 2     +0
; WORD Y            ; 4     +2
; WORD DESTX        ; 6     +4
; WORD DESTY        ; 8     +6
; WORD SPEEDX       ; 10    +8
; WORD SPEEDY       ; 12    +10
; WORD MAXSPEED     ; 14    +12    14 bytez total. / slide struct.

; 
;  INIT_SLIDER ... inits a slider                       
; Ĳ
; In:                                                   
;  EDX -> Slide Structure. Will point to next slide     
;         structure, so you can call this 100 times     
;         if you have 100 slide structs in memory.      
;  SlideX - The starting point horiz.                   
;  SlideY - The starting point vertic.                  
;  DestX - The destination point (orbit) horiz.         
;  DestY - The destination point (orbit) vertic.        
;  AX - Max speed                                       
; 

init_slider:
   push edi ax
   mov edi,edx
   mov ax,SlideX
   mov word ptr [edi],ax        ; X +0
   inc edi
   inc edi

   mov ax,SlideY
   mov word ptr [edi],ax        ; Y +2
   inc edi
   inc edi

   mov ax,DestX
   mov word ptr [edi],ax        ; DEST_X  +4
   inc edi
   inc edi

   mov ax,DestY
   mov word ptr [edi],ax        ; DEST_Y    +6
   inc edi
   inc edi

   mov word ptr [edi],0         ; SPEED X +8
   inc edi
   inc edi

   mov word ptr [edi],0         ; SPEED Y +10 
   inc edi
   inc edi

   pop ax
   mov word ptr [edi],ax        ; MAXSPEED   +12
   inc edi
   inc edi

   mov edx, edi

   pop edi                         ; (+14)

   ret

; 
;  SLIDER_UPDATE ... updates a slider                   
; Ĳ
; In:                                                   
;  EDX -> Slide Structure. Will point to next slide.    
; 

slider_update:
   push eax ebx ecx edx
   ; ------------X (+0) += SPEEDX (+8)
   mov ax,word ptr [edx+8]
   add word ptr [edx],ax
   ; ------------Y (+2) += SPEEDY (+10)
   mov ax,word ptr [edx+10]
   add word ptr [edx+2],ax
   ; ------------IF X (+0) < DEST_X (+4) THEN SPEEDX++ (+8) ELSE SPEEDX-- (+8)
   mov ax,word ptr [edx]
   cmp ax, word ptr [edx+4] 
   jg inc_x                     ; jump if X is ABOVE (=BELOW) DEST_Y 
   mov ax, word ptr [edx+12]    ; Check MAXSPEED (+12)
   cmp word ptr [edx+8],ax      ; SPEED = MAXSPEED??
   je over_inc_x                ; Yea, skip then
   inc word ptr [edx+8]
   jmp over_inc_x
inc_x:
   mov ax,word ptr [edx+12]     ; Check MAXSPEED (+12)
   neg ax
   cmp word ptr [edx+8],ax      ; SPEED = -MAXSPEED??
   je over_inc_x                ; Yea, skip then
   dec word ptr [edx+8]
over_inc_x:

   ; ------------IF Y (+2) < DEST_Y (+6) THEN SPEEDY++ (+10) ELSE SPEEDY-- (+10)
   mov ax,word ptr [edx+2]
   cmp ax, word ptr [edx+6]
   jg inc_y  ; jump if Y is ABOVE (=BELOW) DEST_Y
   mov ax,word ptr [edx+12]
   cmp word ptr [edx+10],ax
   je over_inc_y
   inc word ptr [edx+10]
   jmp over_inc_y
inc_y:
   mov ax,word ptr [edx+12]     ; Check MAXSPEED (+12)
   neg ax
   cmp word ptr [edx+10],ax      ; SPEED = -MAXSPEED??
   je over_inc_y                ; Yea, skip then
   dec word ptr [edx+10]
over_inc_y:

   pop  edx ecx ebx eax
   ret

code32  ends
        end

