.386p
;This file has PMODE.INC as include file!!!
;(for compatibility)

LOWMIN          = 0             ; minimum free low memory (in K)
EXTMIN          = 600           ; minimum free extended memory (in K)
STAKLEN         = 100h          ; stack size in para (keep below or = 1000h)
STAKSAFE        = 20h           ; safe stack space in para

code16  segment para public use16 ; 'code'
code16  ends
code32  segment para public use32  ; 'code'
code32  ends
codeend segment para stack use32 'stack'
codeend ends

extrn   _pm_info:far, _pm_init:far              ; Pmode switch routines by TRAN... btw.. all this is made by TRAN (/RENAISSANCE).. 'reorganised' (=trashed) by Daan Nusman)

code16  segment para public use16
	assume cs:code16, ds:code16

errmsg0         db      '386 or better not detected!!!',7,'$'
errmsg1         db      'Not enough low memory!!!',7,'$'
errmsg2         db      'This system is already in V86 mode!!!',7,'$'
errmsg3         db      'Not enough extended memory!!!',7,'$'
errmsg4         db      'Couldn''t enable A20 gate!!!',7,'$'
errmsg5         db      'Extended memory allocation failure. (weird eh???)',7,'$'

nullint         db      0cfh            ; IRET instruction

d_errmsg0       db      'DPMI host is not 32bit!!!',7,'$'
d_errmsg1       db      'Ran out of DPMI descriptors!!!',7,'$'
d_errmsg2       db      'Couldn''t set DPMI descriptors as needed!!!',7,'$'
d_errmsg3       db      'Could not init DPMI system',7,'$'

pregetlomem:                            ; Get low memory or abort
	; Get EAX bytes..
	add eax,ds:_lomembase
	mov ebx,ds:_lomemtop
	cmp eax,ebx
	ja short pregetlomema           ; over top?
	mov ecx,eax                     ; 
	xchg eax,ds:_lomembase          ; eax = ptr, lomemb += memsize...
	sub ebx,ecx
	cmp ebx,LOWMIN*1024             ; chek if enough mem left for program.
	jb short pregetlomema
	ret
pregetlomema:
	mov dx,offset errmsg1
;
exit16err:                              ; Exit program with message
	mov ah,9
	int 21h
	jmp exit
;-----------------------------------------------------------------------------
exit:                                   ; Guess what???
	mov ah,4ch
	int 21h

start16:                                ; Program begins here
	cli
	cld
	push cs
	pop ds

	mov ax,es                       ; set up a bunch of pointers
	movzx eax,ax
	shl eax,4
	mov ds:_pspa,eax
	mov eax, code16
	shl eax, 4
	mov ds:_code16a,eax
	or dword ptr ds:gdt32code16[2],eax
	or dword ptr ds:gdt32data16[2],eax
	mov ebx,code32
	shl ebx,4
	mov ds:_code32a,ebx
	or dword ptr ds:gdt32code32[2],ebx
	or dword ptr ds:gdt32data32[2],ebx
	mov eax,codeend                 
	shl eax,4
	sub eax,ebx
	mov ds:_lomembase,eax
	mov ds:realstackbase,eax
	movzx eax, word ptr es:[2]      ; get.. lowmemtop..
	shl eax,4                       ; seg 2 real lin ptr
	sub eax,ebx                     ; real to relative lin ptr...
	mov ds:_lomemtop,eax

	mov eax,STAKLEN*16              ; get stack memory
	call pregetlomem                ;---> nothing is done with ptr EAX???? .oops... in realmembase yezz..

	call _pm_info
	cmp ax, 0
	je cont
	mov ds:v86r_dx, offset errmsg0
	jmp d_exit16err
cont:

	; Things setted now:
	; AX - ret. code  .. 0 = suc6
	; BX - nr of para's needed for PMODE buffer
	; CL - Processor type
	; CH - Mode Type (raw/XMS/VCPI/DPMI)

	movzx eax,bx                    ; get mem for DPMI blok
	inc eax                         ; safe T valve
	shl eax,4                       ; from para's to uhm.. bytes.
	call pregetlomem                ; EAX = lin. ptr to mem block
	shr eax, 4                      ; to seg...
	add ax, code32                  ; un rel to code32 segment.. shouldn't this be code16??
	mov es, ax                      ; put it in ES... (needed by _pm_init routine...)

	call _pm_init                   ; Ladies and gentlemen.. we are now in protected mode...


	cli                             ; I don't trust DPMI
	; Get the current DPL level...
	 ;push ax bx cx dx
	 ;mov dl, '@'
	 ;mov ah, 2
	 ;int 21h

	 ;mov dx,cs                       ; get DPL from current CPL, and access
	 ;lar cx,dx                       ;  rights and type from current CS
	 ;mov dl, cl
	 ;add dl, '0'                    ; display DPL/CPL
	 ;mov ah, 2
	 ;int 21h
	 ;pop  dx cx bx ax



	mov ds:v86r_dx, offset d_errmsg3
	cmp ax, 0
	jne exit16err
	mov ds:v86r_dx,dx               ; prepare for abort maybe
	mov ds:data16sel, ds
	mov ds:code16sel, cs
	mov ds:code16off, offset d_exit ; set return to real mode addx

	push ds                         ; no more need for PSP
	pop es
	xor eax, eax                    ; clr ff wat troep...
	xor ebx, ebx
	xor ecx, ecx
	mov ax,3                        ; get selector increment value ; AX = 3
	int 31h                         
	mov bx,ax                       ; BX = DESCR SIZE IN MEM
	xor ax,ax                       ; AX = 0 (get 3 needed descriptors)
	mov cx,3                        ; CX = 3 selectors needed
	int 31h                         ; AX = BASE SELECTOR
	jc d_exit16err

; BX = inc value, ax = base selector SIZE!!

	mov si,ax                       ; set up descriptors SI = base selector
	mov ds:_selcode,ax              ; set up selcode...  = AX
	lea ecx,[eax+ebx]
	mov ds:_seldata,cx              ; set seldata   = CX
	lea ebp,[ecx+ebx]
	mov ds:_selzero,bp              ; set selzeo    = BP
	mov ds:v86r_dx,offset d_errmsg2 ; set msg in case of error....
	mov ax,000Ch                    ; set descriptors from GDT (8-byte buffers)
	mov bx,si                       ; Selector: SI = first = code seletor..
	mov edi,offset ds:gdt32code32
	;or byte ptr [edi+5],60h        ; 0110 0000  = set DPL to 3...
	and byte ptr [edi+5],10011111b  ; set DPL  to zero (must use the LAR instruction, neve heard of this one...)
	;mov word ptr [edi+5], 1100111110011010b ; Well what do you think of THIS HAHAHA!!   DPL = 0 here...
	int 31h
	jc d_exit16err

	mov ax,0Ch
	mov bx,cx                       ; CX = seldata selector.....
	mov edi,offset ds:gdt32data32
	;or byte ptr [edi+5],60h
	and byte ptr [edi+5],10011111b  ; set DPL  to zero (must use the LAR instruction, neve heard of this one...)
	int 31h
	jc d_exit16err

	mov bx, bp
	mov ax, 0Ch
	mov edi,offset ds:gdt32zero32
	;or byte ptr [edi+5],60h
	and byte ptr [edi+5],10011111b  ; set DPL  to zero (must use the LAR instruction, neve heard of this one...)
	int 31h
	jc d_exit16err
	
	mov es,cx                       ; ES, FS, and GS what they should be
	mov fs,cx
	mov gs,bp

	mov edi,ds:_lomembase           ; chek and get extended memory
	mov eax,ds:_lomemtop
	sub eax,edi
	cmp eax,48
	mov ds:v86r_dx,offset errmsg1   ; not enough mem?
	jb d_exit16err                  ; not enough mem.

	mov ax,500h                     ; function 500: get free memory information..
	int 31h
	mov eax,es:[edi+14h]            ; ES:EDI buffer contains largest availiable free block
	cmp eax,-1                      ; check for not avail...
	jne short d_startf0
	mov eax,(EXTMIN+3) shr 2        ;

;        push ax dx
;        mov dl, 'H'
;        mov ah, 2
;        int 21h
;        xor ax,ax
;        int 16h
;        pop dx ax

d_startf0:                              ; enough avail...
	shl eax,12                      ; only 12 bits (imp for mem allocation) remain...
	mov edx,eax
	shr eax,10                      ; 2 bits shuffle (= *4 = mem avail in para's)
	cmp eax,EXTMIN                  ; chek if enough avail...
	mov ds:v86r_dx,offset errmsg3   ; messey 'not engouh ext mem'
	jb d_exit16err
	or edx,edx                      ; EDX = 0? (more than one meg to be allocated)
	jz short d_startf1              ; yups, skip
	mov cx,dx                       ; 
	shld ebx,edx,16                 ; 
	mov ax,501h                     ; allocate block BX:CX in size..
	int 31h
	mov ds:v86r_dx,offset errmsg5   ; err: 'ext mem allocation'
	jc d_exit16err
	mov ds:si_handle, si            ; save handle
	mov ds:di_handle, di
	shl ebx,16
	mov bx,cx                       ; EBX  = BX:CX
	sub ebx,ds:_code32a             ; rlp
	mov ds:_himembase,ebx           ; base
	add ebx,edx                     ;  and
	mov ds:_himemtop,ebx            ;   top
d_startf1:

;        mov ax,305h                     ; get save/restore state addxs
;        int 31h
;        mov ds:dp_savelen,ax
;        mov dword ptr ds:dp_saveaddx[0],edi
;        mov word ptr ds:dp_saveaddx[4],si
;        mov word ptr d_saveaddx[0],cx
;        mov word ptr d_saveaddx[2],bx
;        mov ax,306h                     ; get switch mode addxs
;        int 31h
;        mov dword ptr ds:dp_switchaddx[0],edi
;        mov word ptr ds:dp_switchaddx[4],si
;        mov word ptr d_switchaddx[0],cx
;        mov word ptr d_switchaddx[2],bx
;
;        mov ax,400h                     ; set IRQ handlers to PIC values
;        int 31h
;        xchg dl,dh
;        mov bx,dx
;        call setintslots

;        mov ah,2                        ; backup and set all int vektorz
;        mov si,ds:_selcode
;        mov edi,19
;d_startl0:
;        mov bl,ds:intslottbl[edi]
;        mov al,4
;        int 31h
;        lea ebp,[edi*2+edi]
;        mov dword ptr ds:dp_ointbuf[ebp*2],edx
;        mov word ptr ds:dp_ointbuf[ebp*2+4],cx
;        mov al,5
;        mov edx,d_nintoff[edi*4]
;        mov cx,si
;        int 31h
;        sub di,1
;        jnc d_startl0

	mov ax,es                       ; set up needed regs & go on to 32bit  (ES = dataseg...)
	mov ss,ax                       ; SS = DATASEG...
	add esp,ds:realstackbase        ; SS:ESP pts2 allocated stack base...
	mov ds,ax                       ; DS = DATASEG
	push dword ptr cs:_selcode      
	push offset p_start
	db 66h,0cbh                     ; 32bit RETF  ;CS = CODESEG

;
d_exit16err:                            ; DPMI Exit with error message
	mov ds:v86r_ds,code16
	mov ds:v86r_ah,9
	mov ax,300h
	mov bx,21h
	xor cx,cx
	mov edi,offset ds:v86r_edi
	push ds
	pop es
	int 31h
;
d_exit:                                 ; DPMI exit to real mode
	push cs
	pop ds
	mov si, ds:si_handle            ; free ext. mem block
	mov di, ds:di_handle
	mov ax, 0502h
	int 31h                         ; No errors  EXPECTED here.

;        mov ax, 3                       ; Switch to normal video mode , cls, csr update, bios update...
;        int 10h
	jmp exit

code16  ends


code32  segment para public use32
	assume cs:code32, ds:code32
	org 0

extrn   _main:near

public  _exit, _ret, _getmem, _getlomem, _gethimem, _lomemsize, _himemsize
public  _getirqmask, _setirqmask

public  v86r_eax, v86r_ebx, v86r_ecx, v86r_edx, v86r_esi, v86r_edi, v86r_ebp
public  v86r_ax, v86r_bx, v86r_cx, v86r_dx, v86r_si, v86r_di, v86r_bp
public  v86r_al, v86r_ah, v86r_bl, v86r_bh, v86r_cl, v86r_ch, v86r_dl, v86r_dh
public  v86r_ds, v86r_es, v86r_fs, v86r_gs
public  v86r_ss, v86r_sp, v86r_cs, v86r_ip
public  _selcode, _seldata, _selzero, _lomembase, _lomemtop, _himembase
public  _himemtop, _pspa, _code16a, _code32a
;_getirqvect, _setirqvect

public  simint33
	

;
; 32 bit common system data
;
_lomembase      dd      ?               ; low mem base for allocation
_lomemtop       dd      ?               ; top of low mem
_himembase      dd      0               ; high mem base for allocation
_himemtop       dd      0               ; top of high mem
_pspa           dd      ?               ; offset of start of PSP from 0
_code16a        dd      ?               ; offset of start of 16bit code from 0
_code32a        dd      ?               ; offset of start of 32bit code from 0
_selcode        dw      8               ; code segment selector
_seldata        dw      10h             ; data segment alias for code
_selzero        dw      18h             ; data segment starting at 0:0

gdt32           dq      0
			; seg limit = 4G... seg start = code32
gdt32code32     db      0ffh,0ffh,0,0,0,9ah,0cfh,0
gdt32data32     db      0ffh,0ffh,0,0,0,92h,0cfh,0
gdt32zero32     db      0ffh,0ffh,0,0,0,92h,0cfh,0
gdt32code16     db      0ffh,0ffh,0,0,0,9ah,0,0
gdt32data16     db      0ffh,0ffh,0,0,0,92h,0,0
gdt32task       db      0ffh,0ffh,0,0,0,89h,0,0
gdt32vcpi       dq      3 dup(?)

code16off       dw      d_exit          ; offset in 16bit of exit function (orig c_retreal)
code16sel       dw      20h             ; 16bit pmode code selector
data16sel       dw      28h             ; 16bit pmode data selector

nextmodestack   dw      (STAKLEN-STAKSAFE)*16   ; stack for next mode switch
realstackbase   dd      ?               ; linear ptr to beginning of codeend

si_handle       dw      ?               ; PMODE/DPMI handle for ext mem block in prot. mode
di_handle       dw      ?

v86r_edi        label   dword           ; vregs for pmode<>real communication
v86r_di         dw      ?, ?            ;  needz to stay this way cuz its a
v86r_esi        label   dword           ;  stupid DPMI structure thingy
v86r_si         dw      ?, ?
v86r_ebp        label   dword
v86r_bp         dw      ?, ?
clr1            dd      0
v86r_ebx        label   dword
v86r_bx         label   word
v86r_bl         db      ?
v86r_bh         db      ?, ?,?
v86r_edx        label   dword
v86r_dx         label   word
v86r_dl         db      ?
v86r_dh         db      ?, ?,?
v86r_ecx        label   dword
v86r_cx         label   word
v86r_cl         db      ?
v86r_ch         db      ?, ?,?
v86r_eax        label   dword
v86r_ax         label   word
v86r_al         db      ?
v86r_ah         db      ?, ?,?
v86r_flags      dw      ?
v86r_es         dw      ?
v86r_ds         dw      ?
v86r_fs         dw      ?
v86r_gs         dw      ?
v86r_ip         dw      ?
v86r_cs         dw      ?
v86r_sp         dw      ?
v86r_ss         dw      ?

p_start:
		call init_m3            ; mode 03 init... assures the text system is inited coorecly BEFORE calling the main program

		jmp _main


;
; Allocate any mem, (first cheks low, then high)
; In:
;   EAX - size requested
; Out:
;   CF=0 - memory allocated
;   CF=1 - not enough mem
;   EAX - linear pointer to mem or ?
;
_getmem:
	push eax
	call _getlomem
	jnc short getmemd
	pop eax
	jmp short _gethimem
getmemd:
	add esp,4
_ret:                                   ; generic RET instruction
	ret
;
; Allocate some low mem
; In:
;   EAX - size requested
; Out:
;   CF=0 - memory allocated
;   CF=1 - not enough mem
;   EAX - linear pointer to mem or ?
;
_getlomem:
	add eax,_lomembase         ; eax = _lowmembase + eax
	cmp eax,_lomemtop          ; is over top??
	ja short getmemerr         ; Yea, error > exit
	xchg eax,_lomembase        ; Make new lowmembase (eax points to begin of mem block)  ... Geez... real smart programming..

	clc
	ret
getmemerr:
	stc
	ret

;
; Allocate some high mem
; In:
;   EAX - size requested
; Out:
;   CF=0 - memory allocated
;   CF=1 - not enough mem
;   EAX - linear pointer to mem or ?
;
_gethimem:
	add eax,_himembase
	cmp eax,_himemtop
	ja short getmemerr
	xchg eax,_himembase

	clc
	ret
;
; Get amount of free low mem
; Out:
;   EAX - number of bytes free
;
_lomemsize:
	mov eax,_lomemtop
	sub eax,_lomembase
	ret
;
; Get amount of free high mem
; Out:
;   EAX - number of bytes free
;
_himemsize:
	mov eax,_himemtop
	sub eax,_himembase
	ret
;
; Get status of IRQ mask bit
; In:
;   BL - IRQ num (0-15)
; Out:
;   AL - status: 0=enabled, 1=disabled
;
_getirqmask:
	push ax
	in al,0a1h
	mov ah,al
	in al,21h
	xchg cl,bl
	shr ax,cl
	xchg cl,bl
	and al,1
	mov [esp],al
	pop ax
	ret

;
; Set status of IRQ mask bit
; In:
;   BL - IRQ num (0-15)
;   AL - status: 0=enabled, 1=disabled
;
_setirqmask:
	push ax bx cx dx
	mov cl,bl
	mov bx,0fffeh
	movzx dx,al
	rol bx,cl
	shl dx,cl
	in al,0a1h
	mov ah,al
	in al,21h
	and ax,bx
	or ax,dx
	out 21h,al
	mov al,ah
	out 0a1h,al
	pop dx cx bx ax
	ret

;
; Simulate old int 33h from PMODE 2.1232 (or so..)
; Replace  INT 33h      with    CALL simint33
; In:   AL        - int nr
;       V88R_XXX  - must be setup
;

warn    db 'Newreg EDI <> old reg EDI !!!!!', 0
warn2   db 'ERROR returned from int 31h  function 0300!!!!!!',0

simint33:
	; V86R struct is setup by guest program (i hope)
	push es edi eax ebx ecx edx
	mov  bl, al                      ; X-fer
	xor  bh, bh                      ;
	push ds
	pop  es
	mov  edi, offset v86r_edi        ; EDI = stupid (?) structure
	pushf                            ; Push Flags                           \
	pop  ax                          ; Put in AX
	mov  v86r_flags, ax              ; Put in FLAGS register
	mov  ax, 0300h
	xor  cx, cx                      ; 0 words to copy from PMODE to REAL stack..
	mov  edx, edi
	mov  dword ptr clr1, 0                   ; Clear SS:SP shit like that...
	mov  dword ptr v86r_ip, 0
	mov  dword ptr v86r_sp, 0
	mov  edx, edi
	push edx
	int  31h                         ; Call PMODE / DPMI server
	pop  edx
	cmp  edx, edi
	je   ar
	mov  edx, offset warn
	call printf
	jmp  _exit
ar:
	cmp  ah, 80h
	jne  ar2
	mov  edx, offset warn2
	call printf
	jmp  _exit
ar2:
	mov  ax, v86r_flags              ; Xfer flags back
	push ax
	popf
	pop  edx ecx ebx eax edi es      ; Does a POP affect the flags? I don't hope so.
	ret                              ; ... aaand back!!

_exit:
	; set csr to csr_x, csr_y...

	mov ax, csr_x
	mov dl, al
	mov ax, csr_y
	mov dh, al
	mov ah,2
	mov bh,0
	int 10h

	cli
	push code16sel                  ; go to 16bit pmode exit code
	push code16off
	mov ds, data16sel
	db 66h, 0cbh             ; 16bit RETF

;
;      IRQ'S Disable & enable (Disabling causes speedup!! => Demoz)        
;

;AGAIN... courtesy TRAN

oirqm           db      ?,?
oirq1           dw      ?,?

	PUBLIC irqsoff
	PUBLIC irqson

irqsoff:
	in al,21h                       ; Mask off ALL IRQs except 1
	mov oirqm[0],al
	mov al,0fdh
	out 21h,al
	in al,0a1h
	mov oirqm[1],al
	mov al,0ffh
	out 0a1h,al
	ret

irqson:
	mov al,oirqm[0]                 ; Reset IRQ masks
	out 21h,al
	mov al,oirqm[1]
	out 0a1h,al
	ret


;
;      Mode 03 system                                                      
;

;
; VARIABLES                               
;

PUBLIC csr_x, csr_y, orig_video
PUBLIC fgcolor, bgcolor
orig_video      db ?
csr_x           dw ?
csr_y           dw ?
csr_x_max       dw ?
csr_y_max       dw ?
fgcolor         db ?
bgcolor         db ?
printchar       dd ?                    ; This is a modifiable routine (in case of other gfx modes)

;
; INIT_M3 Inits the mode 03 system        
;Ĳ
; In:  Nothing                            
;Ĳ
; Out: Nothing (regs changed, vidmode 03) 
;

init_m3:
	; At 0040:0049: CRT mode byte.
	;Abs: 00400 (40<<4)
	;     00049+
	;     -----
	;      0449h
	mov al, GS:[449h]       ; Get videomode byte in AL
	mov orig_video, al
	cmp al, 3
	je  no_modesw
	mov ax, 3               ; switch to old mode...
	int 10h
	mov ax, 0
	mov bx, 0
	jmp over_getcsr
no_modesw:
	; Get csr..
	mov ah, 15
	int 10h
	mov ah,3
	int 10h
	movzx ax, dl
	movzx bx, dh
over_getcsr:
	mov word ptr csr_x, ax
	mov word ptr csr_y, bx
	mov word ptr csr_x_max, 80
	mov word ptr csr_y_max, 25
	mov byte ptr fgcolor, 7
	mov byte ptr bgcolor, 0
	mov printchar, offset print_char_mode_03
	ret

;
; PRINT_CHAR_MODE_03 Does what is says.   
;Ĳ
; In:  AL - character (printed on csr)    
;Ĳ
; Out: Nothing                            
;

print_char_mode_03:
	push eax ebx ecx edx edi esi
	push ax
	xor  eax, eax
	mov  ax, csr_y
	mov  edi, eax
	imul edi, 160
	mov  ax, csr_x
	mov  esi, eax
	shl  esi, 1
	lea  edi,[edi+esi+0b8000h]
	sub  edi,_code32a                ; --prot mode modification
	pop  ax
	mov  ah, bgcolor                 ; AH = color
	shl  ah,4
	or   ah, fgcolor
	stosw
	inc  word ptr csr_x
	cmp  word ptr csr_x, 80
	jne  no_wrap
	call key_enter
no_wrap:
	pop esi edi edx ecx ebx eax
	ret

key_enter:
	mov word ptr csr_x, 0
	inc word ptr csr_y
	cmp word ptr csr_y, 25
	jne no_scroll
	; Leave scrolling for later, makamess!
	mov word ptr csr_y, 24       ; Csr must remain on last line...
	; Do a non-BIOS scroll (i felt like that)
	mov eax, 80*24*2
	call _getlomem
	mov   esi, 0b8000h+160
	sub   esi, _code32a
	mov   edi, eax
	mov   ecx, 80*24
	push  eax
	rep   movsw
	pop   esi
	mov   edi, 0b8000h
	sub   edi, _code32a
	mov   ecx, 80*24
	rep   movsw
	mov   ecx, 80
	mov   al, ' '
	mov   ah, bgcolor                 ; AH = color
	shl   ah,4
	or    ah, fgcolor
	rep   stosw
	sub   _lomembase, 80*24*2
no_scroll:
	ret


;
; PRINTF Prints a string with all kinds   
;  of control codes in it                 
;Ĳ
; In:  EDX -> string                      
;Ĳ
; Out: Nothing (regs preserved)           
;

_ps_eax      dd ?
_ps_ebx      dd ?
_ps_ecx      dd ?
_ps_edx      dd ?
tempstr      db 20 dup (?)
callthis     dd ?
printf_d     dd ?   

; Codes:    [x] %A    prints EAX (decimals, just normal)
;           [ ] %0A   prints null-traced EAX
;           [x] %XA   prints hex EAX
;           [ ] %0XA  prints null-traced hex EAX...
;           [x] \n    next line
;           [ ] %$A   prints string pointed to by eax (this cannot be a string with codes)
;           [x] \x00  prints hex code 00 (MUST BE 2 chars, ex. \x02, \xFF, \x0F blablabla)
;           [x] \\    normal \
;           [x] \c0   sets foreground color to 0 (MUST BE ONE CHAR eg. \cF \c7... etc) (\f0... etc also worx)
;           [x] \b0   sets background color to 0 (MUST BE ONE CHAR eg. \bF \c0... etc)
;           [x] \k    waits for a key at that point (used mainly for messages and debugging)
;
;Of course, %A can also be %B for EBX..., or %C for ECX

PUBLIC printf
PUBLIC printf_dest              ; New MACRO version, don't call
PUBLIC printf_d                 ; var for macro version...
;--- MACRO entry point
;- eg.  print o text_dbs   (EDX FREE FOR USE)
printf_dest:
	mov  _ps_eax, eax
	mov  _ps_ebx, ebx
	mov  _ps_ecx, ecx
	mov  _ps_edx, edx               ; This is ofcourse quite useless (EDX points to string)
	
	push eax ebx ecx edx edi esi
	mov  edx, printf_d
	cmp  b [edx], 0
	je   popret             ; haha.. i've forgotten to pop the flags... there..
	jmp  printchrlp

;--- CALL entry point (EDX -> string)
;- eg.  mov edx, o text_dbs
;       call printf                  ; edx used             
printf:
	cmp  b [edx], 0                 ; Chek if there's ANYTHING to print..
	je   _ret                       ; Nope? Then it's clear... get out.

	mov  _ps_eax, eax
	mov  _ps_ebx, ebx
	mov  _ps_ecx, ecx
	mov  _ps_edx, edx               ; This is ofcourse quite useless (EDX points to string)
	push eax ebx ecx edx edi esi

;^v> this area won't be supported by printf_dest!!!!!! think before you put any core betw. push and label

printchrlp:
	  mov  do_zt, 0                 ; No zero tracing...
	  call getchar                  ; Get character in AL...
	  cmp  al, '%'                  ; Check %-code
	  jne  no_percent_code
	    mov  callthis, offset display_number
	    call getchar                ; Get code
	    call downchar               ; down
	    cmp  al, '0'                ; Do we want a lot of zeros?!
	    jne  no_zt
	    mov  do_zt,1                ; Yups, activate option...
	    call getchar                ; Get next control code.. duh..
	    call downchar
no_zt:
	    cmp  al, 'x'
	    jne  no_hex_routine
	    ;INIT HEX MODE:
	      mov  callthis, offset display_hexnumber
	      call getchar                ; Now get real register
	      call downchar
no_hex_routine:
	    sub  al, 'a'
	    movzx ebx, al
	    shl  ebx, 2                 ; x2, x4  (DWORD align)
	    mov  eax, _ps_eax+ebx
	    call [callthis]

	    jmp dontprintchar           ; .. aand back..

no_percent_code:
	  cmp  al, '\'                  ; Check \-code
	  jne  no_slash_code
	    call getchar                ; Get control code..
	    call downchar               ; Downcase it
	    cmp  al, 'n'                ; -----------\n----------
	    jne  no_enter_code
	    call key_enter              ; Yes, issue an ENTER...
	    jmp  dontprintchar
no_enter_code:
	    cmp  al, '\'                ; ----------\\-----------
	    je   do_printchar           ; Yes, print this one...
	    cmp  al, 'c'                ; ----------\c-----------
	    je   col_adj
	    cmp  al, 'f'                ; (or \f, I seem to get confused all of the time...)
	    je   col_adj
	    jmp  no_color_adjust        ; Yes,
col_adj:
	    call getchar                ; get the color number in hex..
	    call onehex_tonum           ; get the hex in AL...
	    mov  byte ptr fgcolor, al   ; set the foreground color
	    jmp  dontprintchar          ; dont print this.. ofcourse..
no_color_adjust:
	    cmp  al, 'b'                ; ----------\b-----------
	    jne  no_bgcolor_adjust      ; Yes,
	    call getchar                ; get the color number in hex..
	    call onehex_tonum           ; get the hex in AL...
	    mov  byte ptr bgcolor, al   ; set the background color
	    jmp  dontprintchar          ; dont print this.. ofcourse..
no_bgcolor_adjust:
	    cmp  al, 'x'                ; ----------\x----------
	    jne  no_hexprint            ; Yes,
	    call getchar                ; get character one
	    call onehex_tonum           ; convert to hex
	    shl  al, 4                  ; and convert to 1st hex
	    mov  ah, al
	    call getchar                ; do it again
	    call onehex_tonum
	    or   al, ah                 ; combine
	    jmp  do_printchar           ; and print the result...
no_hexprint:
	    cmp  al, 'k'                ; ----------\k----------
	    jne  no_waitkey
	    mov  ah, 0
	    int  16h
no_waitkey:
	    jmp  dontprintchar

no_slash_code:                          ; No \-code, no %-code, print normal character...
do_printchar:
	  call [printchar]              ; Call character printing routine in proper mode....
dontprintchar:
	call peekahead                  ; Chek if next thing is a 0-byte (=terminator)
	cmp  al, 0
	jne  printchrlp
popret:
	pop  esi edi edx ecx ebx eax
	ret

getchar:
	mov  al, byte ptr [edx]
	inc  edx
	ret

peekahead:
	mov  al, byte ptr [edx]
	ret

downchar:
	cmp  al, 'A'
	jl   _ret
	cmp  al, 'Z'
	jg   _ret
	add  al, 32                     ; Is upper, cvt to lower...
	ret

onehex_tonum:
	call downchar                   ; downcase any big letters...
	cmp  al, 'a'                    ; Check if letter...
	jge  letter
	sub  al, '0'                    ; Here, it's a number..
	ret
letter:
	sub  al, 'a'-10                 ; Here is's a letter..
	ret

; eax = getal
do_zt  db ?
deler  dd ?
getal  dd ?
zero   db ?
b      equ byte ptr
d      equ dword ptr

display_number:
     push eax ebx ecx edx edi esi
     mov b zero, 1
     mov d deler, 1000000000
     mov d getal, eax
     mov ecx, 10                ; FFFFFFFFh = 4294967296d   (10 cijfers max dus)
convloop2:
     push ecx
     mov eax, getal     ; GETAL/DELER
     mov ebx, deler
     xor edx, edx
     idiv ebx
     cmp al,0
     jne no_zero
     ; Check if first zero(s)
     cmp b do_zt, 1
     je  no_zero        ; print zero anyway if user wants zeros!
     cmp b zero,1
     jne no_zero        ; if not a trailing zero, print it.
     cmp d deler, 1     ; als we het laatste getalletje printen, print dan wel een nul, anders wordt er nix geprint als eax=0
     je no_zero
     jmp dontprint      ; else dont print it.
no_zero:
     add al, '0'         ; Numb2ascii
     call [printchar]
     mov b zero, 0
     sub al, '0'        ; ascii2numb..
dontprint:
     mov ecx, deler     ; (GETAL/DELER)*DELER
     xor edx, edx
     mul ecx
     sub getal, eax     ; GETAL-((GETAL/DELER)*DELER)
     ; deler/=10
     mov eax, deler
     mov ebx,10
     xor edx, edx
     idiv ebx
     mov deler, eax
     pop ecx
     loop convloop2
     pop esi edi edx ecx ebx eax
     ret

hextbl          db      '0123456789ABCDEF'

; Display EAX in hex
display_hexnumber:
     push eax ebx ecx edx edi esi
	
     mov ebx,offset hextbl
     mov edx,eax
     mov ecx,8
     mov b zero, 1

puthexnuml0:
     rol edx,4
     mov al,dl
     and al,0fh
     xlat
     cmp al, '0'                         
     jne hex_dontchek
     cmp do_zt,1
     je  hex_dontchek                   ; Do zero anyway if zero trace is on..
     cmp b zero, 1                      ; If zero, chek if we've
     je hex_dontprint                   ; had any numbers OTHER than zero before
hex_dontchek:
     mov b zero, 0                      ; Set nonzero flag
     call [printchar]
hex_dontprint:
     loop puthexnuml0

     cmp b zero, 1                      ; Have we printed anything?
     jne hex_exit                       ; Yups, exit
     mov al, '0'                        ; Nope, print just this one 0
     call [printchar]
hex_exit:
     pop  esi edi edx ecx ebx eax
     ret

code32 ends

;
; End of program (must be at end of program or you will suffer) i've noticed;) [ult]
;
codeend segment para stack use32 'stack'
db STAKLEN*16 dup(?)
codeend ends

end start16
