; externals for routines from xmode.inc

        extrn  screen_width:word
        extrn  screen_height:word

        extrn  screentable:word;s

        extrn  last_page:word
        extrn  page_addr:word

        extrn  page_size:word

        extrn  display_page:word
        extrn  active_page:word

        extrn  current_page:dword

        extrn  current_xoffset:word
        extrn  current_yoffset:word

        extrn  current_moffset:dword

        extrn  max_xoffset:word
        extrn  max_yoffset:word

        extrn  charset_low:dword
        extrn  charset_hi:dword

        extrn  left_clip_mask:byte
        extrn  right_clip_mask:byte

        extrn  set_vga_modex:near
        extrn  set_modex:near
        extrn  clear_vga_screen:near
        extrn  set_point:near
        extrn  read_point:near
        extrn  fill_block:near
        extrn  draw_line:near
        extrn  set_dac_register:near
        extrn  load_dac_registers:near
        extrn  read_dac_registers:near
        extrn  set_active_page:near
        extrn  get_active_page:near
        extrn  set_display_page:near
        extrn  get_display_page:near
        extrn  set_window:near
        extrn  get_x_offset:near
        extrn  get_y_offset:near
        extrn  sync_display:near
        extrn  initpages:near 
        extrn  flippages:near
        extrn  gprintc:near
        extrn  tgprintc:near
        extrn  print_str:near
        extrn  tprint_str:near
        extrn  set_display_font:near
        extrn  draw_bitmap:near
        extrn  tdraw_bitmap:near
        extrn  copy_page:near
        extrn  copy_bitmap:near
        extrn  mode03:near
        extrn  wipeoffpalette:near
        extrn  fadeoffpalette:near
        extrn  fadeonpalette:near
        extrn  turn_screen_off:near
        extrn  turn_screen_on:near
        extrn  wdraw_bitmap:near


; ===== vga register values =====        may come handy sometimes (XMODE.ASM)

vga_segment     equ d 0a0000h ; vga memory segment

attrib_ctrl     equ 03c0h   ; vga attribute controller
gc_index        equ 03ceh   ; vga graphics controller
sc_index        equ 03c4h   ; vga sequencer controller
sc_data         equ 03c5h   ; vga sequencer data port
crtc_index      equ 03d4h   ; vga crt controller
crtc_data       equ 03d5h   ; vga crt controller data
misc_output     equ 03c2h   ; vga misc register
input_1         equ 03dah   ; input status #1 register

dac_write_addr  equ 03c8h   ; vga dac write addr register
dac_read_addr   equ 03c7h   ; vga dac read addr register
pel_data_reg    equ 03c9h   ; vga dac/pel data register r/w

pixel_pan_reg   equ 033h    ; attrib index: pixel pan reg
map_mask        equ 002h    ; sequ index: write map mask reg
read_map        equ 004h    ; gc index: read map register
start_disp_hi   equ 00ch    ; crtc index: display start hi
start_disp_lo   equ 00dh    ; crtc index: display start lo

map_mask_plane1 equ 00102h  ; map register + plane 1
map_mask_plane2 equ 01102h  ; map register + plane 1
all_planes_on   equ 00f02h  ; map register + all bit planes

chain4_off      equ 00604h  ; chain 4 mode off
async_reset     equ 00100h  ; (a)synchronous reset
sequ_restart    equ 00300h  ; sequencer restart

latches_on      equ 00008h  ; bit mask + data from latches
latches_off     equ 0ff08h  ; bit mask + data from cpu

vert_retrace    equ 08h     ; input_1: vertical retrace bit
plane_bits      equ 03h     ; bits 0-1 of xpos = plane #
all_planes      equ 0fh     ; all bit planes selected
char_bits       equ 0fh     ; bits 0-3 of character data

get_char_ptr    equ 01130h  ; vga bios func: get char set
rom_8x8_lo      equ 03h     ; rom 8x8 char set lo pointer
rom_8x8_hi      equ 04h     ; rom 8x8 char set hi pointer
